open Tk

(*
 * Progress indicators
 *)
let okcolor = NamedColor "#3cb371"
and kocolor = NamedColor "#dc5c5c"


let new_vertical parent w h =
  let f = Frame.create parent 
      	    [Width (Pixels w); Height (Pixels h); 
      	     Relief Sunken; BorderWidth (Pixels 1)] in
  let initfill = [Width (Pixels w); Height (Pixels 0); Background okcolor]
  and initempty = [Width (Pixels w); Height (Pixels h)] in
  let ffill = Frame.create f initfill
  and fempty = Frame.create f initempty in
     pack[ffill][Side Side_Bottom; Fill Fill_X];
     pack[fempty][Side Side_Top; Fill Fill_Both];

  f, (function
	   0 -> Frame.configure ffill initfill;
	        Frame.configure fempty initempty
         | -1 -> Frame.configure ffill [Background kocolor]
         | n ->
	    let percent = if n > 100 then 95 else n in
      	    let hf = percent*h/100 in
		  Frame.configure ffill [Height (Pixels hf)];
		  Frame.configure fempty [Height (Pixels (h - hf))])

let new_horizontal parent w h =
  let f = Frame.create parent 
      	    [Width (Pixels w); Height (Pixels h); 
      	     Relief Sunken; BorderWidth (Pixels 1)] in
  let initfill = [Width (Pixels 0); Height (Pixels h); Background okcolor]
  and initempty = [Width (Pixels w); Height (Pixels h)] in
  let ffill = Frame.create f initfill
  and fempty = Frame.create f initempty in
     pack[ffill][Side Side_Left; Fill Fill_Y];
     pack[fempty][Side Side_Right; Fill Fill_Both];

  f, (function
           0 -> Frame.configure ffill initfill;
	        Frame.configure fempty initempty
	 | -1 -> Frame.configure ffill [Background kocolor]
         | n ->
	    let percent = if n > 100 then 95 else n in
            let wf = percent*w/100 in
		  Frame.configure ffill [Width (Pixels wf)];
		  Frame.configure fempty [Width (Pixels (w - wf))])

